controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::class,
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::class,
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }

    

    public function actionEjercicio1(){
        $alumnos=['Mario','Ana','Maheva','Denis'];
        // $alumnos = "hola";
        return $this->render('ejercicio1',['alumnos'=>$alumnos]);
    }
    public function actionEjercicio2a(){
        $fotos = [
            "pic.jpg",
            "foto1.jpg",
            "foto2.jpg",
            "foto3.jpg"
        ];
        return $this->render('ejercicio2a',['imagenes'=>$fotos]);
    }
    public function actionEjercicio2b(){
        $fotos = [
            "pic.jpg",
            "foto1.jpg",
            "foto2.jpg",
            "foto3.jpg"
        ];
        return $this->render('ejercicio2b',['imagenes'=>$fotos]);
    }
    public function actionEjercicio3($id = 0){
        $alumnos = [
        [
            "nombre" => "Mario",
            "poblacion" => "Madrid",
            "imagen" => "pic.jpg"
        ]
        ,
        [
            "nombre" => "Ana",
            "poblacion" => "Barcelona",
            "imagen" => "foto1.jpg"
        ]
        ,
        [
            "nombre" => "Maheva",
            "poblacion" => "Valencia",
            "imagen" => "foto2.jpg"
        ]
        ,
        [
            "nombre" => "Denis",
            "poblacion" => "Sevilla",
            "imagen" => "foto3.jpg"
        ]
        ];
        //le quito la imagen al alumno para pasarlo solo
        $alumnosSinFoto = $alumnos[$id];
        unset($alumnosSinFoto['imagen']);
        return $this->render('ejercicio3',[
            'alumno'=>$alumnos[$id],
            'alumnosSinFoto'=>$alumnosSinFoto
        ]);
    }
    public function actionEjercicio4(){
        $numeros=[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20];
        return $this->render('ejercicio4',[
            'numeros'=>$numeros
        ]);
    }

    public function actionEjercicio5(){
        $datos = [
            [
                'id' => 1,
                'nombre' => 'Mario',
                'poblacion' => 'Madrid',
                'direccion' => 'Calle 1'
            ],
            [
                'id' => 2,
                'nombre' => 'Ana',
                'poblacion' => 'Barcelona',
                'direccion' => 'Calle 2'
            ],
            [
                'id' => 3,
                'nombre' => 'Maheva',
                'poblacion' => 'Valencia',
                'direccion' => 'Calle 3'
            ],
            [
                'id' => 4,
                'nombre' => 'Denis',
                'poblacion' => 'Sevilla',
                'direccion' => 'Calle 4'
            ]
            ];

            //que en una vista se muestre los datos anteriores
            //utilizando cards
            // en el titulo me colocan el id de cada elemento
            //en el texto de la card el nombre
            //el resto de los campos en una lista dentro del card 
            // con el formato asi Nombre del campo valor


        return $this->render('ejercicio5',[
            'datos'=>$datos
        ]);

    }

    public function actionEjercicio6(){
        $datos = [
            [
                'id' => 1,
                'nombre' => 'Mario',
                'poblacion' => 'Madrid',
                'direccion' => 'Calle 1'
            ],
            [
                'id' => 2,
                'nombre' => 'Ana',
                'poblacion' => 'Barcelona',
                'direccion' => 'Calle 2'
            ],
            [
                'id' => 3,
                'nombre' => 'Maheva',
                'poblacion' => 'Valencia',
                'direccion' => 'Calle 3'
            ],
            [
                'id' => 4,
                'nombre' => 'Denis',
                'poblacion' => 'Sevilla',
                'direccion' => 'Calle 4'
            ]
            ];
            //que en una vista se muestre los datos anteriores
            //utilizando cards
            // en el titulo me colocan el id de cada elemento
            //en el texto de la card el nombre
            //el resto de los campos en una lista dentro del card 
            // con el formato asi Nombre del campo valor

            // en este caso utilizar vistas o sub vistas de bootstrap
            //realizar rende dentro de la vista

            return $this->render('ejercicio5',[
                'datos'=>$datos
            ]);
    }
}

views/layouts/main.php
<?php

/** @var yii\web\View $this */
/** @var string $content */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap5\Breadcrumbs;
use yii\bootstrap5\Html;
use yii\bootstrap5\Nav;
use yii\bootstrap5\NavBar;

AppAsset::register($this);

$this->registerCsrfMetaTags();
$this->registerMetaTag(['charset' => Yii::$app->charset], 'charset');
$this->registerMetaTag(['name' => 'viewport', 'content' => 'width=device-width, initial-scale=1, shrink-to-fit=no']);
$this->registerMetaTag(['name' => 'description', 'content' => $this->params['meta_description'] ?? '']);
$this->registerMetaTag(['name' => 'keywords', 'content' => $this->params['meta_keywords'] ?? '']);
$this->registerLinkTag(['rel' => 'icon', 'type' => 'image/x-icon', 'href' => Yii::getAlias('@web/favicon.ico')]);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">
<head>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body class="d-flex flex-column h-100">
<?php $this->beginBody() ?>

<header id="header">
    <?php
    NavBar::begin([
        'brandLabel' => Yii::$app->name,
        'brandUrl' => Yii::$app->homeUrl,
        'options' => ['class' => 'navbar-expand-md navbar-dark bg-dark fixed-top']
    ]);
    echo Nav::widget([
        'options' => ['class' => 'navbar-nav'],
        'items' => [
            ['label' => 'Home', 'url' => ['/site/index']],
            ['label' => 'Ejercicio1', 'url' => ['/site/ejercicio1']],
            ['label' => 'Ejercicio2', 'items' =>[
                ['label' => 'Ejercicio2 - Foreach', 'url' => ['/site/ejercicio2b']],
                ['label' => 'Ejercicio2 - UL', 'url' => ['/site/ejercicio2a']],
                ]],
            ['label' => 'Ejercicio3', 'items' =>[
                ['label' => 'Ejercicio3 - Alumno 1', 'url' => ['/site/ejercicio3', 'id' => 0]],
                ['label' => 'Ejercicio3 - Almuno 2', 'url' => ['/site/ejercicio3', 'id' => 1]],
                ['label' => 'Ejercicio3 - Almuno 3', 'url' => ['/site/ejercicio3','id' => 2]],
                ['label' => 'Ejercicio3 - Almuno 4', 'url' => ['/site/ejercicio3','id' => 3]],
            ]],
            ['label' => 'Ejercicio4', 'url' => ['/site/ejercicio4']],
            ['label' => 'Ejercicio5', 'url' => ['/site/ejercicio5']],
            ['label' => 'Ejercicio6', 'url' => ['/site/ejercicio6']],
        ]
    ]);
    NavBar::end();
    ?>
</header>

<main id="main" class="flex-shrink-0" role="main">
    <div class="container">
        <?php if (!empty($this->params['breadcrumbs'])): ?>
            <?= Breadcrumbs::widget(['links' => $this->params['breadcrumbs']]) ?>
        <?php endif ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</main>

<footer id="footer" class="mt-auto py-3 bg-light">
    <div class="container">
        <div class="row text-muted">
            <div class="col-md-6 text-center text-md-start">&copy; My Company <?= date('Y') ?></div>
            <div class="col-md-6 text-center text-md-end"><?= Yii::powered() ?></div>
        </div>
    </div>
</footer>

<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>

views/site/_ejercicio6Item.php
<div class="col-sm-3">
      <div class="card">
          <div class="card-header">
              <h3 class="card-title">Id: <?= $dato["id"] ?></h3>
          </div>
          <div class="card-body">
              <p class="card-text">Nombre: <?= $dato["nombre"] ?></p>
          </div>
          <ul class=" list-group list-group-flush">
              <li class="list-group-item">Poblacion: <?= $dato["poblacion"] ?></li>
              <li class="list-group-item">Direccion: <?= $dato["direccion"] ?></li>
          </ul>
      </div>
  </div>

views/site/_elemento.php
<li class="list-group-item" ><?= $numero ?></li>

views/site/_listado.php
<ul class="list-group list-group-horizontal">
    <?php
    foreach ($numeros as $numero) {
        echo  $this->render('_elemento',
         ['numero' => $numero]);
    }
    ?>
</ul>

views/site/ejercicio1.php
<?php

use yii\helpers\Html;

echo Html::textarea('Alumnos',implode('
',$alumnos),[
    'rows'=>5,
    'col'=>20,
    'class' => 'form-control mx-auto text-center'
]);
//var_dump($alumnos);

echo Html::ul($alumnos);

views/site/ejercicio2a.php
<?php

use yii\helpers\Html;
//ramon rules
echo Html::ul($imagenes,[
    'class' => 'list-unstyled list-group list-group-horizontal',//colocar una clase de bootstrap en la etiqueta ul
    'item'=> function($imagen) {
        $salida = "<li class='list-group-item col-lg-3'>";
        $salida .=  Html::img("@web/imgs/{$imagen}", [
            "class" => " img-thumbnail"
        ]);
        $salida .= "</li>";
        return $salida;
    },
    
]);

views/site/ejercicio2b.php
<?php

use yii\helpers\Html;


// realizarlo con foreach
echo "<ul class='list-group list-group-horizontal'>";
foreach ($imagenes as $foto) {
    echo "<li class='list-group-item col-lg-3'>";
    echo Html::img("@web/imgs/{$foto}", [
        'class' => 'img-thumbnail',
    ]);
    echo "</li>";
}
echo "</ul>";


//esta forma la hice para probar imgs helper
// foreach ($imagenes as $imagen){
//     echo Html::img("@web/imgs/{$imagen}", [
//         "class" => "img-responsive rounded col-sm-3 img-thumbnail"
//     ]);
// }

views/site/ejercicio3.php
<?php
//sin utilizar helpers de HTML
 use yii\helpers\Html;
?>
<div class="row">
    <div class="col-sm-3">
        <div class="card">
            <img src="<?= Yii::getAlias("@web") ?>/imgs/<?= $alumno["imagen"] ?>">
            <div class="card-body">
                <p>Nombre: <?= $alumno["nombre"] ?></p>
                <p>Poblacion: <?= $alumno["poblacion"] ?></p>

            </div>
        </div>
    </div>
    <div class="col-sm-3">
        <div class="card">
            <img src="<?= Yii::getAlias("@web") ?>/imgs/<?= $alumno["imagen"] ?>">
            <ul class="list-group list-group-flush">
                <li class="list-group-item">Nombre: <?= $alumno["nombre"] ?></li>
                <li class="list-group-item">Poblacion: <?= $alumno["poblacion"] ?></li>
            </ul>

        </div>
    </div>
</div>

<!-- <ul class="list-group list-group-horizontal">
    <li class="list-group-item">Nombre: <?=$alumno["nombre"]?></li>
    <li class="list-group-item">Poblacion: <?=$alumno["poblacion"]?></li>
    <li class="list-group-item"><img src="<?=Yii::getAlias('@web')?>/imgs/<?=$alumno["imagen"]?>"
    class="col-3"></li>
</ul>


<div class="card">
    <div class="col-sm-3">
        <div class="card">
            <img src="<?=Yii::getAlias('@web')?>/imgs/<?=$alumno["imagen"]?>">
            <div class="card-body">
            <p>Nombre: <?=$alumno["nombre"]?></p>
            <p >Poblacion: <?=$alumno["poblacion"]?></p>
            </div>
    </div>
</div> -->

<!-- Utilizo helpers  -->

<div class="row">
    <div class="col-sm-3">
        <div class="card">
            <?=Html::img("@web/imgs/". $alumno["imagen"])?>
            <?=Html::ul($alumnosSinFoto,[
                'class' => 'list-group list-group-horizontal',
                'itemOptions' => [
                    'class' => 'list-group-item'
                ]
            ])?>
        </div>
    </div>
</div>

views/site/ejercicio4.php
<?php

use yii\helpers\Html;

echo $this->render('_listado',[
    'numeros'=>$numeros
]);


?>

<ul class="list-group list-group-horizontal">
    <?php
        foreach($numeros as $numero){
            echo '<li class="list-group-item">'.$numero.'</li>';
        }
    ?>
</ul>

<?php
echo Html::ul($numeros,[
    'class' => 'list-group list-group-horizontal',
    'itemOptions' => [
        'class' => 'list-group-item'
    ]
]);

views/site/ejercicio5.php
<?php

use yii\helpers\Html;

?>
<div class="row">

  <?php
  foreach($datos as $dato){
  ?>

  <div class="card m-2" style="width: 18rem;">
    <div class="card-header">
      <h2 class="card-title m-2">Id: <?=$dato["id"]?></h2>
    </div>
    <p class="card-text m-3">Nombre: <?=$dato["nombre"]?></p>
    <ul class="list-group list-group-flush">
      
      <li class="list-group-item">Población : <?=$dato["poblacion"]?></li>
      <li class="list-group-item">Dirección : <?=$dato["direccion"]?></li>
    </ul>
  </div>

  <?php
  }
  ?>

</div>

views/site/ejercicio6.php
<?php

// sin utilizar Helpers de HTML

use yii\helpers\Html;

// echo "<div class='row'>";
echo Html::beginTag('div', ['class' => 'row']);
foreach ($datos as $dato) {
    echo $this->render("_ejercicio6Item", ['dato' => $dato]);
}

echo Html::endTag('div');
// echo "</div>";

views/site/error.php
<?php

/** @var yii\web\View $this */
/** @var string $name */
/** @var string $message */
/** @var Exception$exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php

/** @var yii\web\View $this */

$this->title = 'My Yii Application';
?>
<div class="site-index">
    <div class="body-content">

        <div class="row my-lg-n4">
            <div class="col-lg-6 mb-3 mx-auto text-center">
                <h2>Inicio</h2>

                <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.</p>

                <p><a class="btn btn-outline-secondary" href="https://www.yiiframework.com/doc/">boo &raquo;</a></p>
            </div>
           
        </div>

    </div>
</div>